searchNodes=[{"ref":"Talos.html","title":"Talos","type":"module","doc":"Documentation for Talos. Talos is params type validation library, can be used with Phoenix or another Framework Sample usage: defmodule MyAppWeb.UserController do # we define required types and structs alias Talos.Field alias Talos.Types.MapType alias Talos.Types.ListType alias Talos.Types.EnumType alias Talos.Types.NumberType alias Talos.Types.StringType # here we define expected struct @interests_type %EnumType{ members: [ &quot;sports&quot;, &quot;games&quot;, &quot;food&quot; ] } # one struct can be nested in another @user_type %MapType{ fields: [ %Field{key: &quot;email&quot; type: %StringType{min_length: 5, max_length: 255, regexp: ~r/.*@.*/}}, %Field{key: &quot;age&quot; type: %NumberType{gteq: 18}, allow_nil: true}, %Field{key: &quot;interests&quot; type: %ListType{type: @interests_type}, allow_nil: true} ] } def create(conn, params) do case Talos.valid?(@user_type, params) do true -&gt; user = MyApp.create_user(params) conn |&gt; put_flash(:info, &quot;User created successfully.&quot;) |&gt; redirect(to: Routes.user_path(conn, :show, user)) false -&gt; conn |&gt; put_flash(:info, &quot;Wrong params passed.&quot;) |&gt; render(&quot;new.html&quot;) end end end"},{"ref":"Talos.html#errors/2","title":"Talos.errors/2","type":"function","doc":""},{"ref":"Talos.html#valid?/2","title":"Talos.valid?/2","type":"function","doc":""},{"ref":"Talos.Types.html","title":"Talos.Types","type":"behaviour","doc":"Talos Type behaviour You can implement your own data type and use it with another Talos Types iex&gt; defmodule EmailType do iex&gt; @behaviour Talos.Types iex&gt; alias Talos.Types.StringType iex&gt; @email_type %StringType{min_length: 5, regexp: ~r/.*@.*/, max_length: 255} iex&gt; def valid?(_email_type, email) do iex&gt; Talos.valid?(@email_type, email) iex&gt; end iex&gt; def errors(email_type, email) do iex&gt; case valid?(email_type, email) do iex&gt; true -&gt; [] iex&gt; false -&gt; [&quot;not valid email&quot;] iex&gt; end iex&gt; end iex&gt; end iex&gt; Talos.valid?(EmailType, &quot;example@foo.ru&quot;) true iex&gt; Talos.valid?(EmailType, &quot;example&quot;) false iex&gt; Talos.errors(EmailType, &quot;example@foo.ru&quot;) [] iex&gt; Talos.errors(EmailType, &quot;example&quot;) [&quot;not valid email&quot;]"},{"ref":"Talos.Types.html#c:errors/2","title":"Talos.Types.errors/2","type":"callback","doc":""},{"ref":"Talos.Types.html#c:valid?/2","title":"Talos.Types.valid?/2","type":"callback","doc":""},{"ref":"Talos.Types.EnumType.html","title":"Talos.Types.EnumType","type":"module","doc":"Enum type is used to check value to be one of enumerable For example: iex&gt; genders = %Talos.Types.EnumType{members: [&quot;male&quot;, &quot;female&quot;]} iex&gt; Talos.valid?(genders, &quot;male&quot;) true iex&gt; Talos.valid?(genders, &quot;female&quot;) true iex&gt; Talos.valid?(genders, &quot;heli&quot;) false Also there can be another Talos types: iex&gt; digit_string = %Talos.Types.StringType{regexp: ~r/^\\d+$/} iex&gt; numbers = %Talos.Types.EnumType{members: [digit_string, %Talos.Types.IntegerType{}]} iex&gt; Talos.valid?(numbers, &quot;1&quot;) true iex&gt; Talos.valid?(numbers, 1) true iex&gt; Talos.valid?(numbers, &quot;One&quot;) false Additional parameters: allow_nil - allows value to be nil members - list of possible values or TalosTypes"},{"ref":"Talos.Types.EnumType.html#errors/2","title":"Talos.Types.EnumType.errors/2","type":"function","doc":"Callback implementation for Talos.Types.errors/2."},{"ref":"Talos.Types.EnumType.html#valid?/2","title":"Talos.Types.EnumType.valid?/2","type":"function","doc":"Callback implementation for Talos.Types.valid?/2."},{"ref":"Talos.Types.EnumType.html#t:t/0","title":"Talos.Types.EnumType.t/0","type":"type","doc":""},{"ref":"Talos.Types.FixedType.html","title":"Talos.Types.FixedType","type":"module","doc":"Fixed type is used to check value to be equal expected For example: iex&gt; the_4th_planet = %Talos.Types.FixedType{value: &quot;Mars&quot;} iex&gt; Talos.valid?(the_4th_planet, &quot;Earth&quot;) false iex&gt; Talos.valid?(the_4th_planet, &quot;Mars&quot;) true Additional parameters: allow_nil - allows value to be nil"},{"ref":"Talos.Types.FixedType.html#errors/2","title":"Talos.Types.FixedType.errors/2","type":"function","doc":"Callback implementation for Talos.Types.errors/2."},{"ref":"Talos.Types.FixedType.html#valid?/2","title":"Talos.Types.FixedType.valid?/2","type":"function","doc":"Callback implementation for Talos.Types.valid?/2."},{"ref":"Talos.Types.FixedType.html#t:t/0","title":"Talos.Types.FixedType.t/0","type":"type","doc":""},{"ref":"Talos.Types.FloatType.html","title":"Talos.Types.FloatType","type":"module","doc":"Type for check value is float For example: iex&gt; percents = %Talos.Types.FloatType{gteq: 0, lteq: 100} iex&gt; Talos.valid?(percents, 42.0) true iex&gt;Talos.valid?(percents, 136.0) false Additional parameters: allow_nil - allows value to be nil allow_blank - allows value to be blank (0.0) gteq - greater than or equal, same as &gt;= lteq - lower than or equal, same as &lt;= gt - lower than, same as &gt; lt - lower than, same as &lt;"},{"ref":"Talos.Types.FloatType.html#errors/2","title":"Talos.Types.FloatType.errors/2","type":"function","doc":"Callback implementation for Talos.Types.errors/2."},{"ref":"Talos.Types.FloatType.html#valid?/2","title":"Talos.Types.FloatType.valid?/2","type":"function","doc":"Callback implementation for Talos.Types.valid?/2."},{"ref":"Talos.Types.FloatType.html#t:t/0","title":"Talos.Types.FloatType.t/0","type":"type","doc":""},{"ref":"Talos.Types.IntegerType.html","title":"Talos.Types.IntegerType","type":"module","doc":"Type for check value is integer For example: iex&gt; percents = %Talos.Types.IntegerType{gteq: 0, lteq: 100} iex&gt; Talos.valid?(percents, 42) true iex&gt; Talos.valid?(percents, -15) false iex&gt; Talos.valid?(percents, 30.0) false Additional parameters: allow_nil - allows value to be nil allow_blank - allows value to be blank (0) gteq - greater than or equal, same as &gt;= lteq - lower than or equal, same as &lt;= gt - lower than, same as &gt; lt - lower than, same as &lt;"},{"ref":"Talos.Types.IntegerType.html#errors/2","title":"Talos.Types.IntegerType.errors/2","type":"function","doc":"Callback implementation for Talos.Types.errors/2."},{"ref":"Talos.Types.IntegerType.html#valid?/2","title":"Talos.Types.IntegerType.valid?/2","type":"function","doc":"Callback implementation for Talos.Types.valid?/2."},{"ref":"Talos.Types.IntegerType.html#t:t/0","title":"Talos.Types.IntegerType.t/0","type":"type","doc":""},{"ref":"Talos.Types.ListType.html","title":"Talos.Types.ListType","type":"module","doc":"ListType is used to check passed value is a list iex&gt; alias Talos.Types.ListType iex&gt; alias Talos.Types.IntegerType iex&gt; Talos.valid?(%ListType{allow_blank: true}, []) true iex&gt; Talos.valid?(%ListType{allow_nil: true}, nil) true iex&gt; Talos.valid?(%ListType{}, nil) false iex&gt; Talos.valid?(%ListType{}, [&quot;one&quot;, two, 3, %{}]) true iex&gt; Talos.valid?(%ListType{type: %IntegerType{}}, [&quot;one&quot;, two, 3, %{}]) false iex&gt; Talos.valid?(%ListType{type: %IntegerType{}}, [1,2,3]) true iex&gt; Talos.valid?(%ListType{type: %IntegerType{allow_nil: true}}, [nil,2,3]) true Additional parameters: allow_blank - allows array to be empty allow_nil - allows value to be nil type - defines type of array elements"},{"ref":"Talos.Types.ListType.html#errors/2","title":"Talos.Types.ListType.errors/2","type":"function","doc":"Callback implementation for Talos.Types.errors/2."},{"ref":"Talos.Types.ListType.html#valid?/2","title":"Talos.Types.ListType.valid?/2","type":"function","doc":"Callback implementation for Talos.Types.valid?/2."},{"ref":"Talos.Types.ListType.html#t:t/0","title":"Talos.Types.ListType.t/0","type":"type","doc":""},{"ref":"Talos.Types.MapType.html","title":"Talos.Types.MapType","type":"module","doc":"MapType for validation maps Fields are tuples {key, type, options \\ []}: key - string or atom, key of map type - Talos defined Type options: * `optional`: true/false, if false - there will be error on key missing For example: iex&gt; alias Talos.Types.MapType iex&gt; alias Talos.Types.StringType iex&gt; alias Talos.Types.ListType iex&gt; alias Talos.Types.IntegerType iex&gt; alias Talos.Field iex&gt; any_map = %MapType{} iex&gt; Talos.valid?(any_map, %{foo: :bar}) true iex&gt; user_params = %MapType{fields: [ ...&gt; %Field{key: &quot;email&quot;, type: %StringType{min_length: 5, max_length: 255, regexp: ~r/.*@.*/}}, ...&gt; %Field{key: &quot;age&quot;, type: %IntegerType{gteq: 18, allow_nil: true}}, ...&gt; %Field{key: &quot;interests&quot;, type: %ListType{type: %StringType{}}, optional: true} ...&gt; ]} iex&gt; Talos.valid?(user_params, %{}) false iex&gt; Talos.valid?(user_params, %{&quot;email&quot; =&gt; &quot;bob@gmail.com&quot;, &quot;age&quot; =&gt; 30}) true iex&gt; Talos.valid?(user_params, %{&quot;email&quot; =&gt; &quot;bob@gmail.com&quot;, &quot;age&quot; =&gt; 30, interests: [&quot;elixir&quot;]}) true"},{"ref":"Talos.Types.MapType.html#errors/2","title":"Talos.Types.MapType.errors/2","type":"function","doc":"Callback implementation for Talos.Types.errors/2."},{"ref":"Talos.Types.MapType.html#valid?/2","title":"Talos.Types.MapType.valid?/2","type":"function","doc":"Callback implementation for Talos.Types.valid?/2."},{"ref":"Talos.Types.MapType.html#t:t/0","title":"Talos.Types.MapType.t/0","type":"type","doc":""},{"ref":"Talos.Types.NumberType.html","title":"Talos.Types.NumberType","type":"module","doc":"Type for check value is number For example: iex&gt; percents = %Talos.Types.NumberType{gteq: 0, lteq: 100} iex&gt; Talos.valid?(percents, 42) true iex&gt; Talos.valid?(percents, -15) false iex&gt; Talos.valid?(percents, 30.0) true Additional parameters: allow_nil - allows value to be nil gteq - greater than or equal, same as &gt;= lteq - lower than or equal, same as &lt;= gt - lower than, same as &gt; lt - lower than, same as &lt;"},{"ref":"Talos.Types.NumberType.html#errors/2","title":"Talos.Types.NumberType.errors/2","type":"function","doc":"Callback implementation for Talos.Types.errors/2."},{"ref":"Talos.Types.NumberType.html#valid?/2","title":"Talos.Types.NumberType.valid?/2","type":"function","doc":"Callback implementation for Talos.Types.valid?/2."},{"ref":"Talos.Types.NumberType.html#t:t/0","title":"Talos.Types.NumberType.t/0","type":"type","doc":""},{"ref":"Talos.Types.StringType.html","title":"Talos.Types.StringType","type":"module","doc":"Type for check value is string For example: iex&gt; short_domain = %Talos.Types.StringType{length: 3} iex&gt; domains_list = [&quot;cats&quot;, &quot;foo&quot;, &quot;baz&quot;, &quot;pron&quot;] iex&gt; Enum.filter(domains_list, fn str -&gt; Talos.valid?(short_domain, str) end) [&quot;foo&quot;, &quot;baz&quot;] Additional parameters: min_length, same as String.length(str) &lt;= max_length max_length, same as String.length(str) &gt;= max_length length, same as String.length(str) &gt;= length regexp, same as String.match?(str, regexp)"},{"ref":"Talos.Types.StringType.html#errors/2","title":"Talos.Types.StringType.errors/2","type":"function","doc":"Callback implementation for Talos.Types.errors/2."},{"ref":"Talos.Types.StringType.html#valid?/2","title":"Talos.Types.StringType.valid?/2","type":"function","doc":"Callback implementation for Talos.Types.valid?/2."},{"ref":"Talos.Types.StringType.html#t:t/0","title":"Talos.Types.StringType.t/0","type":"type","doc":""},{"ref":"readme.html","title":"Talos","type":"extras","doc":"Talos Talos is simple parameters validation library Documentation can be found at ExDoc"},{"ref":"readme.html#why-another-one-validation-library","title":"Talos - Why another one validation library?","type":"extras","doc":"I needed more checks than just whether the value belonged to one or another type. And I do not like the existing solutions with DSL, which significantly change the language"},{"ref":"readme.html#usage","title":"Talos - Usage","type":"extras","doc":"defmodule CheckUserJSON do # we define required types and structs alias Talos.Field alias Talos.Types.MapType alias Talos.Types.ListType alias Talos.Types.EnumType alias Talos.Types.NumberType alias Talos.Types.StringType # here we define expected struct @interests_type %EnumType{ members: [ &quot;sports&quot;, &quot;games&quot;, &quot;food&quot; ] } # one struct can be nested in another @user_type %MapType{ fields: [ %Field{key: &quot;email&quot;, type: %StringType{min_length: 5, max_length: 255, regexp: ~r/.*@.*/}}, %Field{key: &quot;age&quot;, type: %NumberType{gteq: 18, allow_nil: true}}, %Field{key: &quot;interests&quot;, type: %ListType{type: @interests_type}, optional: true} ] } def validate(map_data) do errors = Talos.errors(@user_type, map_data) case errors == %{} do true -&gt; :ok false -&gt; {:error, errors} end end end Somewhere in UserController ... def new_user(conn, params) case CheckUserJSON.valid?(params) do :ok -&gt; result = MyApp.register_user!(params) render_json(%{&quot;ok&quot; =&gt; true) {:error, errors} -&gt; render_json_errors(errors) end end ..."},{"ref":"readme.html#own-type-definition","title":"Talos - Own Type definition","type":"extras","doc":"If you want define own Type, just create module with Talos.Types behavior defmodule ZipCodeType do @behaviour Talos.Types def valid?(__MODULE__, value) do String.valid?(value) &amp;&amp; String.match?(value, ~r/\\d{6}/) end def errors(__MODULE__, value) do case valid?(__MODULE__,value) do true -&gt; [] false -&gt; [&quot;\#{value} is not zipcode&quot;] end end end # And use it Talos.valid?(ZipCodeType, &quot;123456&quot;) # =&gt; true Talos.valid?(ZipCodeType, &quot;1234&quot;) # =&gt; false Talos.valid?(ZipCodeType, 123456) # =&gt; false"},{"ref":"readme.html#installation","title":"Talos - Installation","type":"extras","doc":"def deps do [ {:talos, &quot;~&gt; 1.0&quot;} ] end"}]